config/routes.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.

require 'sidekiq/web'

class ActionDispatch::Routing::Mapper
  def draw_custom
    ["custom/config/routes.rb", "../custom/config/routes.rb"].each do |filename|
      instance_eval(File.read(Rails.root.join(filename))) if File.file?(filename)
    end
    
  end
end

Scumblr::Application.routes.draw do

  draw_custom

  if(User.devise_modules.include?(:omniauthable))
    devise_for :users , :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }
    match '/users/auth/openid_connect/callback' => 'users/omniauth_callbacks#openid_connect_callback', via: [:get, :post]
    match '/users/auth/openid_connect' => 'users/omniauth_callbacks#openid_connect', via: [:get, :post], as: "openid_connect"
  else
    devise_for :users
  end

  resources :users do
    member do
      post 'toggle_admin'
    end
  end

  resources :system_metadata
  resources :events, only: [:index, :show] do
    collection do
      post 'search' => 'events#index'
      get 'search' => 'events#index'
    end

  end
  resources :flags

  get "user_saved_filters/create"
  get "user_saved_filters/destroy"
  get "saved_filters/new"
  get "saved_filters/destroy"

  resources :saved_filters do
    member do
      post :add
      post :remove
    end
  end



  resources :results do
    collection do
      post 'update_multiple'
      post 'bulk_add'
      post 'search' => 'results#index'
      get 'search' => 'results#index'
      get 'tags/:tag', to: 'results#index', as: :tag
      get 'dashboard'
      get 'workflow_autocomplete'
      post 'update_table_columns'

      get 'expandall', to: 'results#expandall'
      get 'show', to: 'results#show', as: :show_by_name
      get 'expandvulns', to: 'results#expandvulns'
      get 'expandclosedvulns', to: 'results#expandclosedvulns'
      post 'create_vulnerability', to: 'results#create_vulnerability'
    end

    member do
      post 'change_status/:status_id'=>"results#update_status", as: 'update_status'
      post 'comment'  => 'results#comment', :as=> :comment
      post 'tag'  => 'results#tag'
      post 'flag'  => 'results#flag'
      post 'action/:result_flag_id/step/:stage_id'  => 'results#action', as: 'action'
      post 'assign'  => 'results#assign'
      post 'subscribe'  => 'results#subscribe'
      post 'unsubscribe'  => 'results#unsubscribe'
      delete 'tags/:tag_id', to: 'results#delete_tag', as: :delete_tag
      post :add_attachment
      delete 'attachment/:attachment_id', to: 'results#delete_attachment', as: :delete_attachment
      post 'generate_screenshot' => "results#generate_screenshot"
      post 'update_screenshot'
      get 'update_screenshot'
      match 'update_metadata', via: [:get, :post]
      match 'get_metadata', via: [:get, :post]
      get 'summary', to: 'results#summary'
      
      match 'render_metadata_partial', via: [:get, :post]
    end


  end

  resources :tags, only: :index

  resources :tasks do
    collection do
      get 'options', to: 'task_types#options'
      get 'run', to: 'tasks#run'
      post 'bulk_update'
      get 'expandall', to: 'tasks#expandall'
      get :events
    end


    member do
      get 'run', to: 'tasks#run'
      get 'get_metadata'
      post 'enable', to: 'tasks#enable'
      post 'disable', to: 'tasks#disable'
      get 'summary', to: 'tasks#summary'

    end

    member do
      get 'options', to: 'task_types#options'
    end
  end

  resources :statuses do
    member do
      post 'set_default'
    end
  end

  get 'status', to: 'status#status'
  get 'about', to: 'status#about'

  root to: "results#index"

  admin_constraint = lambda do |request|
    request.env['warden'].authenticate? && request.env['warden'].user.admin?
  end

  constraints admin_constraint do
    mount Workflowable::Engine => "/workflowable", as: :workflowable
    mount Sidekiq::Web => '/sidekiq'
    get 'errors', :to => "event_groups#index"
    get 'about', to: 'status#about'
  end

end

app/models/result.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.



class Result < ActiveRecord::Base
  belongs_to :status

  has_many :task_results
  has_many :tasks, :through=>:task_results
  has_many :taggings, as: :taggable, :dependent => :delete_all
  has_many :tags, through: :taggings

  has_many :result_flags
  has_many :flags, through: :result_flags
  has_many :stages, through: :result_flags
  has_many :subscribers, as: :subscribable

  has_many :events, as: :eventable

  has_many :result_attachments

  belongs_to :user

  #attr_accessible :title, :url, :status_id

  validates :url, uniqueness: true
  validates :url, presence: true
  validates_format_of :url, with: /\A#{URI::regexp}\z/

  # serialize :metadata, JSON

  # This field contains the old metadata that is "archived" when moving to jsonb
  # This data is not updated after the migration is run
  serialize :metadata_archive, Hash


  acts_as_commentable

  attr_accessor :current_user

  #before_validation :replace_special_chars
  before_create :set_status

  after_commit :flush_cache

  def flush_cache
    Rails.cache.delete([self.class.name, id])
  end

  # Uncommenting this line will cause a events to be created everytime
  # a result is saved. This can result in a large number of events being
  # stored in an active deployment
  # before_save :create_events

  def self.cached_find(id)
    Rails.cache.fetch([name, id]) { find(id) }
  end



  def self.to_csv
    CSV.generate do |csv|

      attributes = all.try(:first).try(:attributes).try(:keys)
      csv << attributes
      all.each do |result|
        csv << result.attributes.values_at(*attributes)
      end
    end

  end


  def self.valid_column_names
    Result.column_names.reject{|c| c.starts_with("metadata") || c == "content" }+["screenshot", "link"]
  end

  def replace_special_chars
    # puts self.url.to_s
    self.url = self.url.gsub('{', '%7b').gsub('}', '%7d')
  end

  def set_status
    if(self.status.blank?)
      self.status = Status.find_by_default(true)
    end
  end

  after_create :create_task_event

  def create_task_event

    if(Thread.current[:current_task])
      #create an event linking the updated/new result to the task
      #calling_task = Task.where(id: Thread.current[:current_task]).first

      Thread.current["current_results"] ||={}
      Thread.current["current_results"]["created"] ||=[]
      Thread.current["current_results"]["created"] << self.id
      Thread.current["current_results"]["created"].uniq!

      #calling_task.save!
    end
  end

  after_update :update_task_event

  def update_task_event

    if(Thread.current[:current_task])
      #create an event linking the updated/new result to the task
      #calling_task = Task.where(id: Thread.current[:current_task]).first
      Thread.current["current_results"] ||={}
      Thread.current["current_results"]["updated"] ||=[]
      Thread.current["current_results"]["updated"] << self.id
      Thread.current["current_results"]["updated"].uniq!

      #calling_task.save!
    end
  end

  # def create_task_event
  #  if(Thread.current[:current_task])
  #     #create an event linking the updated/new result to the task
  #       calling_task = Task.where(id: Thread.current[:current_task]).first
  #       calling_task.metadata["current_results"] ||={}
  #       puts calling_task.metadata
  #       calling_task.metadata["current_results"]["created"] ||=[]
  #       calling_task.metadata["current_results"]["updated"] ||=[]

  #       if self.new_record?
  #         calling_task.metadata["current_results"]["created"] << self.id
  #       else
  #         calling_task.metadata["current_results"]["updated"] << self.id
  #       end
  #       calling_task.save!
  #  end
  # end

  # Unused method, consider removing Janurary 12th (S.B.)
  # def create_events

  #   # This will catch if the metadata hash was updated directly (i.e. result.metadata[:k] = v)
  #   # But the event will not contain the correct old value. The work around is reassigning the
  #   # metadata value by merging the changes in. I.e.:
  #   # result.metadata = result.metadata.merge(k:v)
  #   # Doing it this will both catch the change and the new/old value.
  #   if(self.metadata_hash != self.metadata.to_json.hash.to_s)
  #     self.metadata_will_change!
  #   end
  #   self.metadata_hash = self.metadata.to_json.hash.to_s



  #   if(self.changes.present?)
  #     event = self.events.build(action: self.new_record? ? "Created" : "Updated", user_id: self.current_user.try(:id) )
  #     self.changes.each do |k, v|
  #       if k == "metadata_hash"
  #         # We don't need to create a record of changes to the metadata hash

  #       elsif(k.ends_with?("_id") && (association = self.class.reflect_on_all_associations.select{|a| a.try(:foreign_key) == k}).present?)
  #         associated_values = association.first.klass.where(id: [ v[0], v[1] ])
  #         event.event_changes.build(field: association.first.class_name,
  #                                   old_value: associated_values.select{|a| a.id == v[0]}.try(:first).to_s,
  #                                   new_value: associated_values.select{|a| a.id == v[1]}.try(:first).to_s,
  #                                   old_value_key: v[0],
  #                                   new_value_key: v[1],
  #                                   value_class: association.first.klass.to_s,
  #                                   )
  #       elsif(self.class.serialized_attributes.keys.include?(k))

  #         event.event_changes.build(field: k.to_s, old_value: v[0].to_s, new_value: v[1].to_s)
  #         HashDiff.diff(v[0] || {},v[1]).each do |diff|
  #           field_name = (k.to_s + ": " + diff[1].to_s).titlecase
  #           if(diff[0] == "-")
  #             event.event_changes.build(field: field_name, old_value: diff[2].to_s, new_value: nil)
  #           elsif(diff[0] == "+")
  #             event.event_changes.build(field: field_name, old_value: nil, new_value: diff[2].to_s)
  #           elsif(diff[0] == "~")
  #             event.event_changes.build(field: field_name, old_value: diff[2].to_s, new_value: diff[3].to_s)
  #           end
  #         end
  #       else
  #         event.event_changes.build(field: k.to_s.titlecase, old_value: v[0].to_s, new_value: v[1].to_s)
  #       end
  #     end
  #   end
  # end


  def to_s
    "Result #{id}"
  end

  # Unused methods and not fully implemented
  # Removed 1-12-17 (S.B.)
  # def self.tagged_with(name)
  #   Tagging.where({:tag_id=>Tag.find_all_by_name(name).map(&:id), :taggable_type=> "Result"}).map{|tagging| tagging.taggable}
  # end

  # def self.tag_counts
  #   Tag.select("tags.*, count(taggings.tag_id) as count").
  #     joins(:taggings).group("taggings.tag_id")
  # end

  def tag_list
    tags.map(&:name).join(", ")
  end

  def tag_list=(names)
    self.tags = names.split(",").map do |n|
      tag = Tag.where("lower(name) like lower(?)",n.strip).first_or_initialize
      tag.name = n.strip if tag.new_record?
      tag.save if tag.changed?
      tag
    end
  end

  def create_attachment_from_url(url)
    attachment = self.result_attachments.new
    attachment.attachment_remote_url = url
    attachment.save
  end

  def create_attachment_from_sketchy(url, status_code_only=false)
    Rails.logger.debug "Getting screenshot #{self.id} "
    sketchy_url = Rails.configuration.try(:sketchy_url)
    if(sketchy_url.blank?)
      Rails.logger.error "No sketch URL configured."
      return
    end

    uri = URI.parse(sketchy_url)
    http = Net::HTTP.new(uri.host, uri.port)
    http.read_timeout = 75
    http.use_ssl = Rails.configuration.try(:sketchy_use_ssl) || false
    if(Rails.configuration.try(:sketchy_use_ssl) && (Rails.configuration.try(:sketchy_verify_ssl) == false || Rails.configuration.try(:sketchy_verify_ssl) == "false"))
      http.verify_mode = OpenSSL::SSL::VERIFY_NONE
    end

    request = Net::HTTP::Post.new(uri.request_uri)
    request.add_field "Content-Type", "application/json"
    if(Rails.configuration.try(:sketchy_access_token).present?)
      request.add_field "Token", Rails.configuration.try(:sketchy_access_token).to_s
    end

    request.body = {:url=>url, :callback=>Rails.application.routes.url_helpers.update_screenshot_result_url(self.id), status_only: (status_code_only == true)}.to_json

    Rails.logger.debug "Sending request #{request.body.inspect}"
    attempts = 0
    begin
      response = http.request(request)

      Rails.logger.debug "Response received #{response.code}"


      if(response.code == "200" || response.code == "201")
        Rails.logger.debug "Sketch OK"
        if(!status_code_only)
          sketchy_id = JSON.parse(response.body).try(:[],"id")
          self.metadata["sketchy_ids"] ||= []

          self.metadata["sketchy_ids"] << sketchy_id
          self.save
        end

      else
        raise RuntimeError
      end

    rescue RuntimeError, EOFError => e
      Rails.logger.error "#{e.inspect}"
      if(attempts < 3)
        attempts += 1
        message = "Retrying due to response from sketchy. #{response.try(:code)}"
        Rails.logger.error message
        retry
      else
        message = "Final failure. Bad response from sketchy. #{response.try(:code)} #{response.try(message)} (#{url})"
        Rails.logger.error message
      end
    end

  rescue StandardError=>e

app/views/tasks/_form.html.erb
<%= form_for(@task) do |f| %>
  <% if @task.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@task.errors.count, "error") %>
        prohibited this task from being saved:</h2>
      <ul>
        <% @task.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="field">
    <%= f.label :name %>
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :group %>
    <% groups = Task.select(&:group).map(&:group).uniq.sort.each_with_index.map{|g,i| [g,"Group #{i+1}"]}
      groups << [groups.try(:last).try(:first).to_i+1, "New Group"]
     %>
    <%= f.collection_select :group, groups, :first, :last, {},  class: "select2" %>
  </div>
  <div class="field">
    <%= f.check_box :enabled %> <%= f.label :enabled %> 
  </div>

  <div class="field">
    <%= f.label :task_type %>
    
    <%= f.grouped_collection_select :task_type, @task_types, :last, :first, :first, :last, {prompt: "Choose a task type"}, {id: :task_type_field, "data-source"=> @task.new_record? ? options_tasks_path : options_task_path(@task) , class: "select2"} %>
  </div>
  <div id="task_description">
    <% if @task_type_configuration.present? || @task_type_description.present?%>
      <%= render :partial=>"task_types/task_configuration", :locals => {:task_options=>@task.try(:options), task_type_options: @task_type_options, task_type_description: @task_type_description, task_type_configuration: @task_type_configuration } %>
    <% end %>
  </div>
  <div class="search_type_field field <%= "hidden" if !@task.task_type.to_s.match(/\ASearchProvider::/) %>">
    <%= f.label :query %>
    <%= f.text_field :query %>
  </div>
  <div id="task_type_options">
    <%= render partial: 'task_types/options_fields', locals: {task_options: @task.options, task_type_options: @task.task_type_options} %>
  </div>
  <div id="tags" class="search_type_field <%= "hidden" if !@task.task_type.to_s.match(/\ASearchProvider::/) %>">
    <%= f.label :tags %>
    <%= f.hidden_field "tag_list", {value: @task.tag_list, class: "remote_select2", "data-multiple"=>true, "data-id-attribute"=>"name" , "data-parse-initial"=>"true", "data-create-new"=>"true", "data-object"=>"tags", "data-attribute"=>"name" , "data-path"=>tags_path} %>
  </div>
  <div class="field">
    <%= f.label :description %>
    <%= f.text_area :description %>
  </div>
  <%= f.submit class: "button" %>
  <%= link_to 'Back', tasks_path, class: "button secondary" %>
<% end %>

app/views/tasks/edit.html.erb
<h1>Editing task</h1>
<%= render 'form' %>

app/views/tasks/index.html.erb
<%= javascript_tag do %>
  window.localStorage.setItem('expanded_all_tasks', "false");
  $(document).ready(function () {
    $("#loading").hide();
  });
$(function(){
  $('#expandall_arrow').click(function(){
        $("#loading").show();
    });

  $(document).ajaxStop(function(){
        $("#loading").hide();
    });
    });
<% end %>
<div id="loading" class="loading" style="display:nont">Loading&#8230;</div>
<div id="selection_table">
  <% i = 1 %>
  <% @tasks.sort.each do |group, tasks| %>
    <nav class="tab-bar">
      <section class="tab-bar-section">
        <h1>Group <%= i %></h1>
      </section>
    </nav>
    <% i += 1 %>
    <table>
      <tr>
        <th><%= link_to "&#9658;".html_safe, expandall_tasks_path(), :id => "expandall_arrow", :remote=>true %></th>
        <th></th>
        <th></th>
        <th>Name</th>
        <th>Task Type</th>
        <th>Query</th>
        <th>Last Success</th>
        <th></th>
      </tr>
      <% tasks.partition{|v| v.enabled == true}.flatten.each do |task| %>
        <tr class="<%= "disabled" if task.enabled != true %>">
          <td><%= link_to "&#9658;".html_safe, summary_task_path(task), :id => "summary_icon_#{task.id}", :remote=>true %></td>
          <td><%= check_box_tag "task_ids[]", task.id, false, {:class=>"result_checkbox"} %></td>
          <% status_class = task.metadata.try(:[], "_last_status").to_s.downcase %>
          <% status_class = "classification-" + status_class if status_class.present? %>
          <% if task.metadata.try(:[], "_last_status") %>
            <% message = task.metadata.try(:[], "_last_status").to_s %>
            <% message +=  "<br/>" + h(task.metadata.try(:[], "_last_status_message").to_s) if task.metadata.try(:[], "_last_status_message") %>
            <% message += "<br/>" + link_to("Event #{task.metadata.try(:[], "_last_status_event")}", event_path(task.metadata.try(:[], "_last_status_event"))) if task.metadata.try(:[], "_last_status_event") %>
            <% message +=  "<br/>Last run: " + time_ago_in_words(DateTime.parse(task.metadata.try(:[], "_last_run").to_s)) + " ago" if task.metadata.try(:[], "_last_run")%>
            <% message +=  "<br/>Last success: " + time_ago_in_words(DateTime.parse(task.metadata.try(:[], "_last_successful_run").to_s)) + " ago" if task.metadata.try(:[], "_last_successful_run")%>
            <% if task.metadata.try(:[], "current_events").try(:[], "Error").present? %>
              <% message += search_form_for Event.search, :url=>search_events_path, :html => {:target=>'_blank'}, :method=>:post, :authenticity_token => false, id:"search_form" do |f| %>
                <% task.metadata["current_events"]["Error"].first(200).each do |error_event| %>
                  <%= hidden_field_tag 'q[id_in][]', error_event %>
                <% end %>
                <%= link_to 'Current Event Errors: ' + task.metadata.try(:[], "current_events").try(:[], "Error").length.to_s, "", {class: "submit_form_link", target: '_blank'} %>
              <% end %>
            <% end %>
            <% if task.metadata.try(:[], "current_events").try(:[], "Warn").present? %>
              <% message += search_form_for Event.search, :url=>search_events_path, :html => {:target=>'_blank'}, :method=>:post, :authenticity_token => false, id:"search_form" do |f| %>
                <% task.metadata["current_events"]["Warn"].first(200).each do |warn_event| %>
                  <%= hidden_field_tag 'q[id_in][]', warn_event %>
                <% end %>
                <%= link_to 'Current Event Warnings: ' + task.metadata.try(:[], "current_events").try(:[], "Warn").length.to_s, "", {class: "submit_form_link", target: '_blank'} %>
              <% end %>
            <% end %>
            <% if task.metadata.try(:[], "current_results").try(:[], "created").present? %>
              <% message += search_form_for Result.search, :url=>search_results_path, :html => {:target=>'_blank'}, :method=>:post, :authenticity_token => false, id:"search_form" do |f| %>
                <% task.metadata["current_results"]["created"].first(200).each do |created_result| %>
                  <%= hidden_field_tag 'q[id_in][]', created_result %>
                <% end %>
                <%= link_to 'Current Results Created: ' + task.metadata.try(:[], "current_results").try(:[], "created").length.to_s, "", {class: "submit_form_link", target: '_blank'} %>
              <% end %>
            <% end %>
            <% if task.metadata.try(:[], "current_results").try(:[], "updated").present? %>
              <% message += search_form_for Result.search, :url=>search_results_path, :html => {:target=>'_blank'}, :method=>:post, :authenticity_token => false, id:"search_form" do |f| %>
                <% task.metadata["current_results"]["updated"].first(200).each_with_index do |index, updated_result| %>
                  <%= hidden_field_tag 'q[id_in][]', updated_result %>
                <% end %>
                <%= link_to 'Current Results Updated: ' + task.metadata.try(:[], "current_results").try(:[], "updated").length.to_s, "", {class: "submit_form_link", target: '_blank'} %>
              <% end %>
            <% end %>
            <% if task.metadata.try(:[], "previous_events").try(:[], "Error").present? %>
              <% message += search_form_for Event.search, :url=>search_events_path, :html => {:target=>'_blank'}, :method=>:post, :authenticity_token => false, id:"search_form" do |f| %>
                <% task.metadata["previous_events"]["Error"].first(200).each do |error_event| %>
                  <%= hidden_field_tag 'q[id_in][]', error_event %>
                <% end %>
                <%= link_to 'Previous Event Errors: ' + task.metadata.try(:[], "previous_events").try(:[], "Error").length.to_s, "", {class: "submit_form_link", target: '_blank'} %>
              <% end %>
            <% end %>
            <% if task.metadata.try(:[], "previous_events").try(:[], "Warn").present? %>
              <% message += search_form_for Event.search, :url=>search_events_path, :html => {:target=>'_blank'}, :method=>:post, :authenticity_token => false, id:"search_form" do |f| %>
                <% task.metadata["previous_events"]["Warn"].first(200).each do |warn_event| %>
                  <%= hidden_field_tag 'q[id_in][]', warn_event %>
                <% end %>
                <%= link_to 'Previous Event Warnings: ' + task.metadata.try(:[], "previous_events").try(:[], "Warn").length.to_s, "", {class: "submit_form_link", target: '_blank'} %>
              <% end %>
            <% end %>
            <% if task.metadata.try(:[], "previous_results").try(:[], "created").present? %>
              <% message += search_form_for Result.search, :url=>search_results_path, :html => {:target=>'_blank'}, :method=>:post, :authenticity_token => false, id:"search_form" do |f| %>
                <% task.metadata["previous_results"]["created"].first(200).each do |created_result| %>
                  <%= hidden_field_tag 'q[id_in][]', created_result %>
                <% end %>
                <%= link_to 'Previous Results Created: ' + task.metadata.try(:[], "previous_results").try(:[], "created").length.to_s, "", {class: "submit_form_link", target: '_blank'} %>
              <% end %>
            <% end %>
            <% if task.metadata.try(:[], "previous_results").try(:[], "updated").present? %>
              <% message += search_form_for Result.search, :url=>search_results_path, :html => {:target=>'_blank'}, :method=>:post, :authenticity_token => false, id:"search_form" do |f| %>
                <% task.metadata["previous_results"]["updated"].first(200).each do |updated_result| %>
                  <%= hidden_field_tag 'q[id_in][]', updated_result %>
                <% end %>
                <%= link_to 'Previous Results Updated: ' + task.metadata.try(:[], "previous_results").try(:[], "updated").length.to_s, "", {class: "submit_form_link", target: '_blank'} %>
              <% end %>
            <% end %>
          <% end %>
          <td class="<%= status_class %> has-tip bettertooltip" data-tooltip data-options="hover_delay: 500;" aria-haspopup="true"  title="<%= message %>">&nbsp;</td>
          <td><%= link_to task.name, task %></td>
          <td><%= task.task_type_name %></td>
          <td><%= task.query %></td>
          <td><%= time_ago_in_words(DateTime.parse(task.metadata.try(:[], "_last_successful_run").to_s)) + " ago" if task.metadata.try(:[], "_last_successful_run")%></td>
          <td>
            <% if task.enabled %>
              <%= link_to 'Disable', disable_task_path(task), method: :post, class: "button tiny" if can? :disable, task %>
            <% else %>
              <%= link_to 'Enable', enable_task_path(task), method: :post, class: "button tiny" if can? :enable, task %>
            <% end %>
            <%= link_to 'Edit', edit_task_path(task), class: "button tiny" if can? :edit, task %>
            <%= link_to 'Duplicate', new_task_path(task_id: task.id), class: "button tiny" if can? :create, Task %>
            <%= link_to 'Destroy', task, method: :delete, data: { confirm: 'Are you sure?' }, class: "button tiny alert" if can? :destroy, task %></td>
        </tr>
        <tr>
          <td colspan="8" style="padding: 0; margin: 0; border: 0;">
            <div id="summary_<%= task.id %>" style="display:none;"> </div>
          </td>
        </tr>
      <% end %>
    </table>
    <br />
  <% end %>
</div>
<%= link_to 'New Task', new_task_path, class: "button" if can? :create, Task %>
<%= link_to 'Run All Enabled Tasks', run_tasks_path, class: "button alert" if can? :run, Task  %>
<%= content_for :sidebar do %>
  <div class="sidebar">
    <nav class="tab-bar">
      <section class="tab-bar-section">
        <h1>Actions</h1>
      </section>
    </nav>
    <section class="panel sidepanel">
      <%= form_tag bulk_update_tasks_path, method: :post, :id=>"update_multiple_form" do %>
        <dl class="dl-horizontal">
          <dt class="half">Move to:</dt>
          <dd>
            <a href="#" data-dropdown="drop_move" class="button dropdown tiny secondary">Choose group</a><br>
            <ul id="drop_move" data-dropdown-content class="f-dropdown">
              <% groups = Task.select(&:group).map(&:group).uniq.sort.each_with_index.map{|g,i| [g,"Group #{i+1}"]}
            groups << [groups.try(:last).try(:first).to_i+1, "New Group"]
           %>
              <% groups.each do |group| %>
                <li><%= link_to group.last, "#", method: :post, class: "update_multiple_link", data: {commit: "Change Group", group_id: group.first} %></li>
              <% end %>
            </ul>
          </dd>
        </dl>
        <% if can? :enable, Task %>
          <%= submit_tag "Enable", :method=>:post, :class=>"button small update_multiple_button" %>
        <% end %>
        <% if can? :disable, Task %>
          <%= submit_tag "Disable", :method=>:post, :class=>"button small update_multiple_button" %>
        <% end %>
        <% if can? :run, Task %>
          <%= submit_tag "Run", :method=>:post, :class=>"button small update_multiple_button" %>
        <% end %>
        <% if can? :destroy, Task %>
          <%= submit_tag "Delete", :method=>:delete, :class=>"button small alert update_multiple_button", data: {:confirm=>"Are you sure you want to delete these tasks?"} %>
        <% end %>
      <% end %>
    </section>
  </div>
<% end %>

app/views/tasks/new.html.erb
<h1>New task</h1>
<%= render 'form' %>